Index: drivers/filesystems/btrfs/extent-tree.c
===================================================================
--- drivers/filesystems/btrfs/extent-tree.c	(révision 75772)
+++ drivers/filesystems/btrfs/extent-tree.c	(copie de travail)
@@ -653,95 +672,111 @@
                 return STATUS_INTERNAL_ERROR;
             }
         }
-        
+
         len -= sectlen;
         ptr += sizeof(UINT8) + sectlen;
         inline_rc += sectcount;
     }
-    
+
     offset = get_extent_hash(type, data);
-    
+
     max_extent_item_size = (Vcb->superblock.node_size >> 4) - sizeof(leaf_node);
-    
+
     // If we can, add entry as inline extent item
-    
+
     if (inline_rc == ei->refcount && tp.item->size + sizeof(UINT8) + datalen < max_extent_item_size) {
         len = tp.item->size - sizeof(EXTENT_ITEM);
         ptr = (UINT8*)&ei[1];
-        
+
         if (ei->flags & EXTENT_ITEM_TREE_BLOCK && !skinny) {
             len -= sizeof(EXTENT_ITEM2);
             ptr += sizeof(EXTENT_ITEM2);
         }
 
+        // Confusingly, it appears that references are sorted forward by type (i.e. EXTENT_DATA_REFs before
+        // SHARED_DATA_REFs), but then backwards by hash...
+
         while (len > 0) {
             UINT8 secttype = *ptr;
             ULONG sectlen = get_extent_data_len(secttype);
-            
+
             if (secttype > type)
                 break;
-            
+
             if (secttype == type) {
                 UINT64 sectoff = get_extent_hash(secttype, ptr + 1);
-                
-                if (sectoff > offset)
+
+                if (sectoff < offset)
                     break;
             }
-            
+
             len -= sectlen + sizeof(UINT8);
             ptr += sizeof(UINT8) + sectlen;
         }
-        
+
         newei = ExAllocatePoolWithTag(PagedPool, tp.item->size + sizeof(UINT8) + datalen, ALLOC_TAG);
         RtlCopyMemory(newei, tp.item->data, ptr - tp.item->data);
-        
+
         newei->refcount += get_extent_data_refcount(type, data);
-        
+
         if (len > 0)
             RtlCopyMemory((UINT8*)newei + (ptr - tp.item->data) + sizeof(UINT8) + datalen, ptr, len);
-        
+
         ptr = (ptr - tp.item->data) + (UINT8*)newei;
-        
+
         *ptr = type;
         RtlCopyMemory(ptr + 1, data, datalen);
-        
-        delete_tree_item(Vcb, &tp, rollback);
-        
-        if (!insert_tree_item(Vcb, Vcb->extent_root, tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, newei, tp.item->size + sizeof(UINT8) + datalen, NULL, Irp, rollback)) {
-            ERR("insert_tree_item failed\n");
-            return STATUS_INTERNAL_ERROR;
+
+        Status = delete_tree_item(Vcb, &tp);
+        if (!NT_SUCCESS(Status)) {
+            ERR("delete_tree_item returned %08x\n", Status);
+            return Status;
         }
-        
+
+        Status = insert_tree_item(Vcb, Vcb->extent_root, tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, newei, tp.item->size + sizeof(UINT8) + datalen, NULL, Irp);
+        if (!NT_SUCCESS(Status)) {
+            ERR("insert_tree_item returned %08x\n", Status);
+            return Status;
+        }
+
         return STATUS_SUCCESS;
     }
-    
+
     // Look for existing non-inline entry, and increase refcount if found
-    
+
     if (inline_rc != ei->refcount) {
         traverse_ptr tp2;
-        
+
         searchkey.obj_id = address;
         searchkey.obj_type = type;
         searchkey.offset = offset;
-        
+
         Status = find_item(Vcb, Vcb->extent_root, &tp2, &searchkey, FALSE, Irp);
         if (!NT_SUCCESS(Status)) {
             ERR("error - find_item returned %08x\n", Status);
             return Status;
         }
-        
+
         if (!keycmp(tp2.item->key, searchkey)) {
-            if (tp2.item->size < datalen) {
+            if (type == TYPE_SHARED_DATA_REF && tp2.item->size < sizeof(UINT32)) {
+                ERR("(%llx,%x,%llx) was %x bytes, expecting %x\n", tp2.item->key.obj_id, tp2.item->key.obj_type, tp2.item->key.offset, tp2.item->size, sizeof(UINT32));
+                return STATUS_INTERNAL_ERROR;
+            } else if (type != TYPE_SHARED_DATA_REF && tp2.item->size < datalen) {
                 ERR("(%llx,%x,%llx) was %x bytes, expecting %x\n", tp2.item->key.obj_id, tp2.item->key.obj_type, tp2.item->key.offset, tp2.item->size, datalen);
                 return STATUS_INTERNAL_ERROR;
             }
-            
+
             data2 = ExAllocatePoolWithTag(PagedPool, tp2.item->size, ALLOC_TAG);
+            if (!data2) {
+                ERR("out of memory\n");
+                return STATUS_INSUFFICIENT_RESOURCES;
+            }
+
             RtlCopyMemory(data2, tp2.item->data, tp2.item->size);
-            
+
             if (type == TYPE_EXTENT_DATA_REF) {
                 EXTENT_DATA_REF* edr = (EXTENT_DATA_REF*)data2;
-                
+
                 edr->count += get_extent_data_refcount(type, data);
             } else if (type == TYPE_TREE_BLOCK_REF) {
                 TRACE("trying to increase refcount of non-shared tree extent\n");
@@ -749,81 +784,123 @@
             } else if (type == TYPE_SHARED_BLOCK_REF)
                 return STATUS_SUCCESS;
             else if (type == TYPE_SHARED_DATA_REF) {
-                SHARED_DATA_REF* sdr = (SHARED_DATA_REF*)data2;
-                
-                sdr->count += get_extent_data_refcount(type, data);
+                UINT32* sdr = (UINT32*)data2;
+
+                *sdr += get_extent_data_refcount(type, data);
             } else {
                 ERR("unhandled extent type %x\n", type);
                 return STATUS_INTERNAL_ERROR;
             }
-            
-            delete_tree_item(Vcb, &tp2, rollback);
-            
-            if (!insert_tree_item(Vcb, Vcb->extent_root, tp2.item->key.obj_id, tp2.item->key.obj_type, tp2.item->key.offset, data2, tp2.item->size, NULL, Irp, rollback)) {
-                ERR("insert_tree_item failed\n");
-                return STATUS_INTERNAL_ERROR;
+
+            Status = delete_tree_item(Vcb, &tp2);
+            if (!NT_SUCCESS(Status)) {
+                ERR("delete_tree_item returned %08x\n", Status);
+                return Status;
             }
-            
+
+            Status = insert_tree_item(Vcb, Vcb->extent_root, tp2.item->key.obj_id, tp2.item->key.obj_type, tp2.item->key.offset, data2, tp2.item->size, NULL, Irp);
+            if (!NT_SUCCESS(Status)) {
+                ERR("insert_tree_item returned %08x\n", Status);
+                return Status;
+            }
+
             newei = ExAllocatePoolWithTag(PagedPool, tp.item->size, ALLOC_TAG);
+            if (!newei) {
+                ERR("out of memory\n");
+                return STATUS_INSUFFICIENT_RESOURCES;
+            }
+
             RtlCopyMemory(newei, tp.item->data, tp.item->size);
-            
+
             newei->refcount += get_extent_data_refcount(type, data);
-            
-            delete_tree_item(Vcb, &tp, rollback);
-            
-            if (!insert_tree_item(Vcb, Vcb->extent_root, tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, newei, tp.item->size, NULL, Irp, rollback)) {
-                ERR("insert_tree_item failed\n");
-                return STATUS_INTERNAL_ERROR;
+
+            Status = delete_tree_item(Vcb, &tp);
+            if (!NT_SUCCESS(Status)) {
+                ERR("delete_tree_item returned %08x\n", Status);
+                return Status;
             }
-            
+
+            Status = insert_tree_item(Vcb, Vcb->extent_root, tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, newei, tp.item->size, NULL, Irp);
+            if (!NT_SUCCESS(Status)) {
+                ERR("insert_tree_item returned %08x\n", Status);
+                return Status;
+            }
+
             return STATUS_SUCCESS;
         }
     }
-    
+
     // Otherwise, add new non-inline entry
-    
-    data2 = ExAllocatePoolWithTag(PagedPool, datalen, ALLOC_TAG);
-    RtlCopyMemory(data2, data, datalen);
-    
-    if (!insert_tree_item(Vcb, Vcb->extent_root, address, type, offset, data2, datalen, NULL, Irp, rollback)) {
-        ERR("insert_tree_item failed\n");
-        return STATUS_INTERNAL_ERROR;
+
+    if (type == TYPE_SHARED_DATA_REF) {
+        SHARED_DATA_REF* sdr = (SHARED_DATA_REF*)data;
+
+        data2 = ExAllocatePoolWithTag(PagedPool, sizeof(UINT32), ALLOC_TAG);
+        if (!data2) {
+            ERR("out of memory\n");
+            return STATUS_INSUFFICIENT_RESOURCES;
+        }
+
+        datalen = sizeof(UINT32);
+
+        *((UINT32*)data2) = sdr->count;
+    } else if (type == TYPE_TREE_BLOCK_REF || type == TYPE_SHARED_BLOCK_REF) {
+        data2 = NULL;
+        datalen = 0;
+    } else {
+        data2 = ExAllocatePoolWithTag(PagedPool, datalen, ALLOC_TAG);
+        if (!data2) {
+            ERR("out of memory\n");
+            return STATUS_INSUFFICIENT_RESOURCES;
+        }
+
+        RtlCopyMemory(data2, data, datalen);
     }
-    
+
+    Status = insert_tree_item(Vcb, Vcb->extent_root, address, type, offset, data2, datalen, NULL, Irp);
+    if (!NT_SUCCESS(Status)) {
+        ERR("insert_tree_item returned %08x\n", Status);
+        return Status;
+    }
+
     newei = ExAllocatePoolWithTag(PagedPool, tp.item->size, ALLOC_TAG);
+    if (!newei) {
+        ERR("out of memory\n");
+        return STATUS_INSUFFICIENT_RESOURCES;
+    }
+
     RtlCopyMemory(newei, tp.item->data, tp.item->size);
-    
+
     newei->refcount += get_extent_data_refcount(type, data);
-    
-    delete_tree_item(Vcb, &tp, rollback);
-    
-    if (!insert_tree_item(Vcb, Vcb->extent_root, tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, newei, tp.item->size, NULL, Irp, rollback)) {
-        ERR("insert_tree_item failed\n");
-        return STATUS_INTERNAL_ERROR;
+
+    Status = delete_tree_item(Vcb, &tp);
+    if (!NT_SUCCESS(Status)) {
+        ERR("delete_tree_item returned %08x\n", Status);
+        return Status;
     }
-    
+
+    Status = insert_tree_item(Vcb, Vcb->extent_root, tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, newei, tp.item->size, NULL, Irp);
+    if (!NT_SUCCESS(Status)) {
+        ERR("insert_tree_item returned %08x\n", Status);
+        return Status;
+    }
+
     return STATUS_SUCCESS;
 }
 
-NTSTATUS increase_extent_refcount_data(device_extension* Vcb, UINT64 address, UINT64 size, UINT64 root, UINT64 inode, UINT64 offset, UINT32 refcount, PIRP Irp, LIST_ENTRY* rollback) {
+NTSTATUS increase_extent_refcount_data(device_extension* Vcb, UINT64 address, UINT64 size, UINT64 root, UINT64 inode, UINT64 offset, UINT32 refcount, PIRP Irp) {
     EXTENT_DATA_REF edr;
-    
+
     edr.root = root;
     edr.objid = inode;
     edr.offset = offset;
     edr.count = refcount;
-    
-    return increase_extent_refcount(Vcb, address, size, TYPE_EXTENT_DATA_REF, &edr, NULL, 0, Irp, rollback);
-}
 
-void decrease_chunk_usage(chunk* c, UINT64 delta) {
-    c->used -= delta;
-    
-    TRACE("decreasing size of chunk %llx by %llx\n", c->offset, delta);
+    return increase_extent_refcount(Vcb, address, size, TYPE_EXTENT_DATA_REF, &edr, NULL, 0, Irp);
 }
 
 NTSTATUS decrease_extent_refcount(device_extension* Vcb, UINT64 address, UINT64 size, UINT8 type, void* data, KEY* firstitem,
-                                  UINT8 level, UINT64 parent, BOOL superseded, PIRP Irp, LIST_ENTRY* rollback) {
+                                  UINT8 level, UINT64 parent, BOOL superseded, PIRP Irp) {
     KEY searchkey;
     NTSTATUS Status;
     traverse_ptr tp, tp2;
@@ -834,91 +911,91 @@
     UINT32 rc = data ? get_extent_data_refcount(type, data) : 1;
     ULONG datalen = get_extent_data_len(type);
     BOOL is_tree = (type == TYPE_TREE_BLOCK_REF || type == TYPE_SHARED_BLOCK_REF), skinny = FALSE;
-    
+
     if (is_tree && Vcb->superblock.incompat_flags & BTRFS_INCOMPAT_FLAGS_SKINNY_METADATA) {
         searchkey.obj_id = address;
         searchkey.obj_type = TYPE_METADATA_ITEM;
         searchkey.offset = 0xffffffffffffffff;
-        
+
         Status = find_item(Vcb, Vcb->extent_root, &tp, &searchkey, FALSE, Irp);
         if (!NT_SUCCESS(Status)) {
             ERR("error - find_item returned %08x\n", Status);
             return Status;
         }
-        
+
         if (tp.item->key.obj_id == searchkey.obj_id && tp.item->key.obj_type == searchkey.obj_type)
             skinny = TRUE;
     }
-    
+
     if (!skinny) {
         searchkey.obj_id = address;
         searchkey.obj_type = TYPE_EXTENT_ITEM;
         searchkey.offset = 0xffffffffffffffff;
-        
+
         Status = find_item(Vcb, Vcb->extent_root, &tp, &searchkey, FALSE, Irp);
         if (!NT_SUCCESS(Status)) {
             ERR("error - find_item returned %08x\n", Status);
             return Status;
         }
-        
+
         if (tp.item->key.obj_id != searchkey.obj_id || tp.item->key.obj_type != searchkey.obj_type) {
             ERR("could not find EXTENT_ITEM for address %llx\n", address);
             return STATUS_INTERNAL_ERROR;
         }
-        
+
         if (tp.item->key.offset != size) {
             ERR("extent %llx had length %llx, not %llx as expected\n", address, tp.item->key.offset, size);
             return STATUS_INTERNAL_ERROR;
         }
-        
+
         if (tp.item->size == sizeof(EXTENT_ITEM_V0)) {
-            Status = convert_old_extent(Vcb, address, is_tree, firstitem, level, Irp, rollback);
-            
+            Status = convert_old_extent(Vcb, address, is_tree, firstitem, level, Irp);
+
             if (!NT_SUCCESS(Status)) {
                 ERR("convert_old_extent returned %08x\n", Status);
                 return Status;
             }
 
-            return decrease_extent_refcount(Vcb, address, size, type, data, firstitem, level, parent, superseded, Irp, rollback);
+            return decrease_extent_refcount(Vcb, address, size, type, data, firstitem, level, parent, superseded, Irp);
         }
     }
-    
+
     if (tp.item->size < sizeof(EXTENT_ITEM)) {
         ERR("(%llx,%x,%llx) was %u bytes, expected at least %u\n", tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, tp.item->size, sizeof(EXTENT_ITEM));
         return STATUS_INTERNAL_ERROR;
     }
-    
+
     ei = (EXTENT_ITEM*)tp.item->data;
-    
+
     len = tp.item->size - sizeof(EXTENT_ITEM);
     ptr = (UINT8*)&ei[1];
-    
+
     if (ei->flags & EXTENT_ITEM_TREE_BLOCK && !skinny) {
         if (tp.item->size < sizeof(EXTENT_ITEM) + sizeof(EXTENT_ITEM2)) {
             ERR("(%llx,%x,%llx) was %u bytes, expected at least %u\n", tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, tp.item->size, sizeof(EXTENT_ITEM) + sizeof(EXTENT_ITEM2));
             return STATUS_INTERNAL_ERROR;
         }
-        
+
         len -= sizeof(EXTENT_ITEM2);
         ptr += sizeof(EXTENT_ITEM2);
     }
-    
+
     if (ei->refcount < rc) {
         ERR("error - extent has refcount %llx, trying to reduce by %x\n", ei->refcount, rc);
         return STATUS_INTERNAL_ERROR;
     }
-    
+
     inline_rc = 0;
-    
+
     // Loop through inline extent entries
-    
+
     while (len > 0) {
         UINT8 secttype = *ptr;
-        ULONG sectlen = get_extent_data_len(secttype);
+        UINT16 sectlen = get_extent_data_len(secttype);
         UINT64 sectcount = get_extent_data_refcount(secttype, ptr + sizeof(UINT8));
-        
+
         len--;
-        
+
         if (sectlen > len) {
             ERR("(%llx,%x,%llx): %x bytes left, expecting at least %x\n", tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, len, sectlen);
             return STATUS_INTERNAL_ERROR;
@@ -928,190 +1005,232 @@
             ERR("(%llx,%x,%llx): unrecognized extent type %x\n", tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, secttype);
             return STATUS_INTERNAL_ERROR;
         }
-        
+
         if (secttype == type) {
             if (type == TYPE_EXTENT_DATA_REF) {
                 EXTENT_DATA_REF* sectedr = (EXTENT_DATA_REF*)(ptr + sizeof(UINT8));
                 EXTENT_DATA_REF* edr = (EXTENT_DATA_REF*)data;
-                ULONG neweilen;
-                EXTENT_ITEM* newei;
-                
+
                 if (sectedr->root == edr->root && sectedr->objid == edr->objid && sectedr->offset == edr->offset) {
+                    UINT16 neweilen;
+                    EXTENT_ITEM* newei;
+
                     if (ei->refcount == edr->count) {
-                        delete_tree_item(Vcb, &tp, rollback);
-                        
+                        Status = delete_tree_item(Vcb, &tp);
+                        if (!NT_SUCCESS(Status)) {
+                            ERR("delete_tree_item returned %08x\n", Status);
+                            return Status;
+                        }
+
                         if (!superseded)
-                            add_checksum_entry(Vcb, address, size / Vcb->superblock.sector_size, NULL, Irp, rollback);
-                        
+                            add_checksum_entry(Vcb, address, (ULONG)(size / Vcb->superblock.sector_size), NULL, Irp);
+
                         return STATUS_SUCCESS;
                     }
-                    
+
                     if (sectedr->count < edr->count) {
                         ERR("error - extent section has refcount %x, trying to reduce by %x\n", sectedr->count, edr->count);
                         return STATUS_INTERNAL_ERROR;
                     }
-                    
+
                     if (sectedr->count > edr->count)    // reduce section refcount
                         neweilen = tp.item->size;
                     else                                // remove section entirely
                         neweilen = tp.item->size - sizeof(UINT8) - sectlen;
-                    
+
                     newei = ExAllocatePoolWithTag(PagedPool, neweilen, ALLOC_TAG);
                     if (!newei) {
                         ERR("out of memory\n");
                         return STATUS_INSUFFICIENT_RESOURCES;
                     }
-                    
+
                     if (sectedr->count > edr->count) {
                         EXTENT_DATA_REF* newedr = (EXTENT_DATA_REF*)((UINT8*)newei + ((UINT8*)sectedr - tp.item->data));
-                        
+
                         RtlCopyMemory(newei, ei, neweilen);
-                        
+
                         newedr->count -= rc;
                     } else {
                         RtlCopyMemory(newei, ei, ptr - tp.item->data);
-                        
+
                         if (len > sectlen)
                             RtlCopyMemory((UINT8*)newei + (ptr - tp.item->data), ptr + sectlen + sizeof(UINT8), len - sectlen);
                     }
-                    
+
                     newei->refcount -= rc;
-                    
-                    delete_tree_item(Vcb, &tp, rollback);
-                    
-                    if (!insert_tree_item(Vcb, Vcb->extent_root, tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, newei, neweilen, NULL, Irp, rollback)) {
-                        ERR("insert_tree_item failed\n");
-                        return STATUS_INTERNAL_ERROR;
+
+                    Status = delete_tree_item(Vcb, &tp);
+                    if (!NT_SUCCESS(Status)) {
+                        ERR("delete_tree_item returned %08x\n", Status);
+                        return Status;
                     }
-                    
+
+                    Status = insert_tree_item(Vcb, Vcb->extent_root, tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, newei, neweilen, NULL, Irp);
+                    if (!NT_SUCCESS(Status)) {
+                        ERR("insert_tree_item returned %08x\n", Status);
+                        return Status;
+                    }
+
                     return STATUS_SUCCESS;
                 }
             } else if (type == TYPE_SHARED_DATA_REF) {
                 SHARED_DATA_REF* sectsdr = (SHARED_DATA_REF*)(ptr + sizeof(UINT8));
                 SHARED_DATA_REF* sdr = (SHARED_DATA_REF*)data;
-                ULONG neweilen;
-                EXTENT_ITEM* newei;
-                
+
                 if (sectsdr->offset == sdr->offset) {
+                    EXTENT_ITEM* newei;
+                    UINT16 neweilen;
+
                     if (ei->refcount == sectsdr->count) {
-                        delete_tree_item(Vcb, &tp, rollback);
-                        
+                        Status = delete_tree_item(Vcb, &tp);
+                        if (!NT_SUCCESS(Status)) {
+                            ERR("delete_tree_item returned %08x\n", Status);
+                            return Status;
+                        }
+
                         if (!superseded)
-                            add_checksum_entry(Vcb, address, size / Vcb->superblock.sector_size, NULL, Irp, rollback);
-                        
+                            add_checksum_entry(Vcb, address, (ULONG)(size / Vcb->superblock.sector_size), NULL, Irp);
+
                         return STATUS_SUCCESS;
                     }
-                    
+
                     if (sectsdr->count < sdr->count) {
                         ERR("error - SHARED_DATA_REF has refcount %x, trying to reduce by %x\n", sectsdr->count, sdr->count);
                         return STATUS_INTERNAL_ERROR;
                     }
-                    
+
                     if (sectsdr->count > sdr->count)    // reduce section refcount
                         neweilen = tp.item->size;
                     else                                // remove section entirely
                         neweilen = tp.item->size - sizeof(UINT8) - sectlen;
-                    
+
                     newei = ExAllocatePoolWithTag(PagedPool, neweilen, ALLOC_TAG);
                     if (!newei) {
                         ERR("out of memory\n");
                         return STATUS_INSUFFICIENT_RESOURCES;
                     }
-                    
+
                     if (sectsdr->count > sdr->count) {
                         SHARED_DATA_REF* newsdr = (SHARED_DATA_REF*)((UINT8*)newei + ((UINT8*)sectsdr - tp.item->data));
-                        
+
                         RtlCopyMemory(newei, ei, neweilen);
-                        
+
                         newsdr->count -= rc;
                     } else {
                         RtlCopyMemory(newei, ei, ptr - tp.item->data);
-                        
+
                         if (len > sectlen)
                             RtlCopyMemory((UINT8*)newei + (ptr - tp.item->data), ptr + sectlen + sizeof(UINT8), len - sectlen);
                     }
 
                     newei->refcount -= rc;
-                    
-                    delete_tree_item(Vcb, &tp, rollback);
-                    
-                    if (!insert_tree_item(Vcb, Vcb->extent_root, tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, newei, neweilen, NULL, Irp, rollback)) {
-                        ERR("insert_tree_item failed\n");
-                        return STATUS_INTERNAL_ERROR;
+
+                    Status = delete_tree_item(Vcb, &tp);
+                    if (!NT_SUCCESS(Status)) {
+                        ERR("delete_tree_item returned %08x\n", Status);
+                        return Status;
                     }
-                    
+
+                    Status = insert_tree_item(Vcb, Vcb->extent_root, tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, newei, neweilen, NULL, Irp);
+                    if (!NT_SUCCESS(Status)) {
+                        ERR("insert_tree_item returned %08x\n", Status);
+                        return Status;
+                    }
+
                     return STATUS_SUCCESS;
                 }
             } else if (type == TYPE_TREE_BLOCK_REF) {
                 TREE_BLOCK_REF* secttbr = (TREE_BLOCK_REF*)(ptr + sizeof(UINT8));
                 TREE_BLOCK_REF* tbr = (TREE_BLOCK_REF*)data;
-                ULONG neweilen;
-                EXTENT_ITEM* newei;
-                
+
                 if (secttbr->offset == tbr->offset) {
+                    EXTENT_ITEM* newei;
+                    UINT16 neweilen;
+
                     if (ei->refcount == 1) {
-                        delete_tree_item(Vcb, &tp, rollback);
+                        Status = delete_tree_item(Vcb, &tp);
+                        if (!NT_SUCCESS(Status)) {
+                            ERR("delete_tree_item returned %08x\n", Status);
+                            return Status;
+                        }
+
                         return STATUS_SUCCESS;
                     }
 
                     neweilen = tp.item->size - sizeof(UINT8) - sectlen;
-                    
+
                     newei = ExAllocatePoolWithTag(PagedPool, neweilen, ALLOC_TAG);
                     if (!newei) {
                         ERR("out of memory\n");
                         return STATUS_INSUFFICIENT_RESOURCES;
                     }
-                    
+
                     RtlCopyMemory(newei, ei, ptr - tp.item->data);
-                    
+
                     if (len > sectlen)
                         RtlCopyMemory((UINT8*)newei + (ptr - tp.item->data), ptr + sectlen + sizeof(UINT8), len - sectlen);
-                    
+
                     newei->refcount--;
-                    
-                    delete_tree_item(Vcb, &tp, rollback);
-                    
-                    if (!insert_tree_item(Vcb, Vcb->extent_root, tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, newei, neweilen, NULL, Irp, rollback)) {
-                        ERR("insert_tree_item failed\n");
-                        return STATUS_INTERNAL_ERROR;
+
+                    Status = delete_tree_item(Vcb, &tp);
+                    if (!NT_SUCCESS(Status)) {
+                        ERR("delete_tree_item returned %08x\n", Status);
+                        return Status;
                     }
-                    
+
+                    Status = insert_tree_item(Vcb, Vcb->extent_root, tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, newei, neweilen, NULL, Irp);
+                    if (!NT_SUCCESS(Status)) {
+                        ERR("insert_tree_item returned %08x\n", Status);
+                        return Status;
+                    }
+
                     return STATUS_SUCCESS;
                 }
             } else if (type == TYPE_SHARED_BLOCK_REF) {
                 SHARED_BLOCK_REF* sectsbr = (SHARED_BLOCK_REF*)(ptr + sizeof(UINT8));
                 SHARED_BLOCK_REF* sbr = (SHARED_BLOCK_REF*)data;
-                ULONG neweilen;
-                EXTENT_ITEM* newei;
-                
+
                 if (sectsbr->offset == sbr->offset) {
+                    EXTENT_ITEM* newei;
+                    UINT16 neweilen;
+
                     if (ei->refcount == 1) {
-                        delete_tree_item(Vcb, &tp, rollback);
+                        Status = delete_tree_item(Vcb, &tp);
+                        if (!NT_SUCCESS(Status)) {
+                            ERR("delete_tree_item returned %08x\n", Status);
+                            return Status;
+                        }
+
                         return STATUS_SUCCESS;
                     }
-                    
+
                     neweilen = tp.item->size - sizeof(UINT8) - sectlen;
-                    
+
                     newei = ExAllocatePoolWithTag(PagedPool, neweilen, ALLOC_TAG);
                     if (!newei) {
                         ERR("out of memory\n");
                         return STATUS_INSUFFICIENT_RESOURCES;
                     }
-                    
+
                     RtlCopyMemory(newei, ei, ptr - tp.item->data);
-                    
+
                     if (len > sectlen)
                         RtlCopyMemory((UINT8*)newei + (ptr - tp.item->data), ptr + sectlen + sizeof(UINT8), len - sectlen);
-                    
+
                     newei->refcount--;
-                    
-                    delete_tree_item(Vcb, &tp, rollback);
-                    
-                    if (!insert_tree_item(Vcb, Vcb->extent_root, tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, newei, neweilen, NULL, Irp, rollback)) {
-                        ERR("insert_tree_item failed\n");
-                        return STATUS_INTERNAL_ERROR;
+
+                    Status = delete_tree_item(Vcb, &tp);
+                    if (!NT_SUCCESS(Status)) {
+                        ERR("delete_tree_item returned %08x\n", Status);
+                        return Status;
                     }
-                    
+
+                    Status = insert_tree_item(Vcb, Vcb->extent_root, tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, newei, neweilen, NULL, Irp);
+                    if (!NT_SUCCESS(Status)) {
+                        ERR("insert_tree_item returned %08x\n", Status);
+                        return Status;
+                    }
+
                     return STATUS_SUCCESS;
                 }
             } else {
